<?php
/**
 * iF.SVNAdmin
 * Copyright (c) 2010 by Manuel Freiholz
 * http://www.insanefactory.com/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; version 2
 * of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 */
include("include/config.inc.php");
if (!$appEngine->isGroupViewActive() && !$appEngine->isAccessPathViewActive())
  $appEngine->forwardInvalidModule(true);
$appEngine->checkUserAuthentication(true, ACL_MOD_GROUP, ACL_ACTION_VIEW);
$appTR->loadModule("groupview");

// Action handling.
$unassign = check_request_var('unassign');
if( $unassign )
{
  $appEngine->handleAction('unassign_usergroup');
}

$unassign_permission = check_request_var('unassign_permission');
if( $unassign_permission )
{
  $appEngine->handleAction('unassign_permission');
}

// Get required variables.
$groupname = get_request_var('groupname');
$appTemplate->addReplacement( "GROUPNAME", $groupname );
$appTemplate->addReplacement( "GROUPNAME_ENCODED", rawurlencode($groupname) );

// Current selected group.
$oGroup = new \svnadmin\core\entities\Group;
$oGroup->id = $groupname;
$oGroup->name = $groupname;

// Users of group
if ($appEngine->isGroupViewActive() && $appEngine->checkUserAuthentication(false, ACL_MOD_GROUP, ACL_ACTION_VIEW))
{
  $users = $appEngine->getGroupViewProvider()->getUsersOfGroup( $oGroup );
  usort( $users, array("\svnadmin\core\entities\User","compare") );
  $appTemplate->addReplacement( "users", $users );
}

// Access-Path permissions of the current group.
if ($appEngine->isAccessPathViewActive() && $appEngine->checkUserAuthentication(false, ACL_MOD_ACCESSPATH, ACL_ACTION_VIEW))
{
  $paths = $appEngine->getAccessPathViewProvider()->getPathsOfGroup( $oGroup );
  usort( $paths, array("\svnadmin\core\entities\AccessPath","compare") );
  $appTemplate->addReplacement( "paths", $paths );
}

// View template.
$appTemplate->loadFromFile( new \IF_File("templates/groupview.html") );
$appTemplate->processTemplate();
?>